#pragma once

#ifndef _MAV_LET_STORAGE_
#define _MAV_LET_STORAGE_

#include "cmnfuncs.h"

typedef unsigned long SDWORD;

// Incremental Storage
class LetStorage
{
public:
	LetStorage(void);
	~LetStorage(void);

	void Free();
	void FreeZ();

	void Expand();
	void Crop();

	SDWORD Append(DWORD value);
	SDWORD Add(DWORD value);
	DWORD Remove();
	DWORD GetValue(SDWORD index);
	DWORD* GetPtr(SDWORD index);
	void SetDefaultValue(DWORD default_value);

	// std data
	DWORD* data;
	SDWORD size;
	SDWORD count;
	DWORD default_value;

	// over
	DWORD* GetArray();
	SDWORD GetCount();
};

#endif
