#include "StdAfx.h"
#include "letstack.h"

LetStack::LetStack(void)
{
	this->checking = false;
	this->current = 0;
}

LetStack::~LetStack(void)
{
	this->checking = false;
	this->current = 0;
}


void LetStack::Push(DWORD value)
{
	if (current > 100)
		PushError(1, "  - \n");
	this->Append(value);
	current++;
}

DWORD LetStack::Pop()
{
	if (current == 0)
		PushError(1, "  - \n");
	current--;
	return this->Remove();
}

DWORD LetStack::SkipPop()
{
	DWORD tmp = this->Remove();
	Push(tmp);
	return tmp;
}

bool LetStack::CheckDivder()
{
	if (this->checking)
		return true;
	return true;
}

DWORD* LetStack::GetPrev(DWORD offset)
{
	return GetPtr(current - offset);
}
